#include "adhesivemachine.h"
//压胶机
AdhesiveMachine::AdhesiveMachine()
{
    //添加各种参数到列表中
    initRootParasList();
    initRootHMIConfigurationList(m_allParasList);//超级用户界面配置
    initRootIOTConfigurationList(m_allParasList); //超级用户物联网配置
    initPatternsParasList();
    initSoftwareParasList(m_allParasList);
    initTimeParasList(m_allParasList);
    initMcParasList();

    //初始化控制动作列表
    initOutCtrlList();

    //初始化快捷功能列表
    initShortCutList();

    //初始化辅助功能列表
    initAssistList();

    //初始化花样设置功能列表
    initPatternSetList();

    //参数分类功能
    initParaSetList();

    //初始化传感器列表
    initSensorList();

    //初始化错误代码和状态列表
    initErrorCodeAndStateList();
}

AdhesiveMachine::~AdhesiveMachine()
{

}

//超级用户参数(包括机器参数、工作参数)
void AdhesiveMachine::initRootParasList()
{
    //超级用户参数---------------------------
    //超级用户参数-界面配置；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_HMICONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("HMI Configuration"),//界面配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0000 , factory));

    //超级用户参数-界面进入调试模式；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DEBUGMODE, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Interface debug mode"),//界面进入调试模式
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , root));

    //超级用户参数-删除config.ini配置文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETEINI, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete configure file"),//删除配置文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 ,  root));

    //超级用户参数-重置花样配置-删除花样fcg文件影响fileid的数据;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_CLEARPATTERNFCG_FILEID, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete pattern configuration"),//删除花样配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001, factory));

    //超级用户参数-导入csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IMPORTCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Import CSV file"),//导入csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-删除csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETECSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete CSV file"),//删除csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-重置安装调试进度；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_RESETCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Reset CSV file"),//重置安装调试进度
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));


    //超级用户参数-机器参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_MACHINEPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Machine parameters"),//机器参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0002, factory));

    //超级用户参数-工作参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_WORKPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Work parameters"),//工作参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0003, factory));

    //超级用户参数-物联网配置;
    m_allParasList.append(makeAParaItem(0,
                                       PARA_TYPE_ROOT,
                                       0 ,
                                       ROOT_IOTCONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                       tr("InternetofThings  configuration"),//物联网配置
                                       0, 0, 0, 0, 0, tr(""), tr(""),
                                       tr(""),
                                       0, 0, 0x000D, factory));
}

//花样参数
void AdhesiveMachine::initPatternsParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    //花样参数-花样设置参数-翻转式样；单位：无 ，范围0-7，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATESTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flip style"),//翻转式样
                                        0, 0, 7, 0, 0, tr(""), tr(""),
                                        tr("normalP:0;nRight90P:1;nRight180P:2;nRight270P:3;mirrorP:4;mRight90P:5;mRight180P:6;mRight270P:7"),
                                        0, 0, 0x0001, operate));

    //花样参数-花样设置参数-水平翻转样式；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_HORIZONTALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Horizontal flip style"),//水平翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-垂直翻转式样；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_VERTICALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("vertical flip style"),//垂直翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-旋转角度；单位：° ，范围0-90，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATEANGLE, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation angle"),//旋转角度
                                        0, 0, 90, 0, 0, cod->toUnicode("°"), tr(""),//度
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-需要分割的针步长度；单位：mm，范围3-20，默认7
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_SPLITSTITCHLENGTH, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of the stitch that needs to be split"),//需要分割的针步长度
                                        700, 300, 2000, 700, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-起始点x；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_STARTX, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startX"),//起始点x
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0004, operate));

    //花样参数-花样设置参数-起始点y；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_STARTY, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startY"),//起始点y
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0004, operate));
    //花样参数---------------------------
}

//机器参数
void AdhesiveMachine::initMcParasList()
{
    // XY电机启停转速, 范围 1--5000，单位mm/s，默认 10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        0, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY motor start and stop speed"),
                                        10, 1, 5000, 10, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // XY电机归零转速, 范围 1--5000，单位mm/s，默认 20
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        1, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY motor return to zero speed"),
                                        20, 1, 5000, 20, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // XY电机运转转速, 范围 1--5000，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY motor running speed"),
                                        100, 1, 5000, 100, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // XY电机运转加速度, 范围 1--5000，单位mm/ss，默认 30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        3, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY motor operating acceleration"),
                                        30, 1, 5000, 30, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x0003, operate));

    // 升降启动速度,1--100 mm/s，默认 30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        4, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lifting start speed"),
                                        30, 1, 100, 30, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0004, operate));

    // 升降归零速度,1--100 mm/s，默认 30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        5, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lifting and returning to zero speed"),
                                        30, 1, 100, 30, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0005, operate));

    // 升降行走速度,1--1500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        6, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lifting and walking speed"),
                                        200, 1, 1500, 200, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0006, operate));

    // 升降行走加速度,1--10000 mm/s2，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        7, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lifting and walking acceleration"),
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""), 0, 0, 0x0007, operate));



    // 慢动速度，范围 1--5000，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        50, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Slow motion speed"),
                                        100, 1, 5000, 100, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0032, operate));

    // 工作速度，范围 1--5000，单位mm/s，默认 20
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        51, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Operating speed"),
                                        20, 1, 5000, 20, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0033, operate));

    // 工作加速度, 范围 1--5000，单位mm/ss，默认 30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        52, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Working acceleration"),
                                        30, 1, 5000, 30, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x0034, operate));

    // 工作最高速度，范围 1--1000，单位mm/s，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        53, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Maximum operating speed"),
                                        200, 1, 1000, 200, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0035, operate));

    // 工作最小速度，范围 1--1000，单位mm/s，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        54, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Minimum operating speed"),
                                        200, 1, 1000, 200, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0036, operate));

    // X电机零位坐标，范围-500000--5000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        100, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Zero position coordinate of X motor"),// X电机零位坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0064, operate));

    // Y电机零位坐标，范围-500000--5000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        101, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Zero position coordinate of Y motor"),// Y电机零位坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0065, operate));

    // 升降电机零位坐标，范围-500000--5000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        102, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Zero position coordinate of lifting motor"), // 升降电机零位坐标
                                        0, -500000, 5000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0066, operate));

    // X电机归零补偿，范围-10000--10000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        103, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Zero compensation of X motor"), // X电机归零补偿
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0067, operate));

    // Y电机归零补偿，范围-10000--10000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        104, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y motor zeroing compensation"), // Y电机归零补偿
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0068, operate));

    // 升降电机归零补偿，范围-10000--10000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        105, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Zero compensation of lifting motor"), // 升降电机归零补偿
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0069, operate));

    // 偏移点X坐标，范围-500000--5000000，单位0.01mm，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        106, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point X coordinate"),
                                        200, -500000, 5000000, 200, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x006A, operate));

    // 偏移点Y坐标，范围-500000--5000000，单位0.01mm，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point Y coordinate"),
                                        200, -500000, 5000000, 200, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x006B, operate));

    // 校准点坐标X，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        108, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Calibration point coordinate X"),
                                        0,  -1000000,  1000000,  0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x006C, operate));

    // 校准点坐标Y，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        109, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Calibration point coordinate Y"),
                                        0,  -1000000,  1000000,  0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x006C, operate));

    // 校准传感器高度，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Calibrate sensor height"),
                                        0,  -1000000,  1000000,  0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x006C, operate));

    // 机头升降低位坐标，-500000--5000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        150, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lower position coordinate of head lifting"),
                                        0, -500000, 5000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0096, operate));

    // 机头升降高位坐标，-500000--5000000，单位0.01mm，默认10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        151, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lifting high position coordinate"),
                                        10000, -500000, 5000000, 10000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0097, operate));

    // 机头升降上边界,单位0.01mm,默认10000，范围-500000--5000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        152, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lifting upper boundary"),
                                        10000, -500000, 5000000, 10000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0098, operate));

    // 机头升降下边界，单位0.01mm,默认1000，范围-500000--5000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        153, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lower boundary of nose lifting"),
                                        1000, -500000, 5000000, 1000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0099, operate));

    // X1 正向软限位，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        154, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X1 positive soft limit"),
                                        1000000,  -1000000,  1000000,  1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009A, operate));

    // X1 负向软限位，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        155, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X1 negative soft limit"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009B, operate));

    // X2 正向软限位，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        156, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X2 positive soft limit"),
                                        1000000,  -1000000,  1000000,  1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009C, operate));

    // X2 负向软限位，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        157, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X2 Negative soft limit"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009D, operate));

    // Y 正向软限位，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        158, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y positive direction soft limit"),
                                        1000000, -1000000, 1000000, 1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009E, operate));

    // Y 负向软限位，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        159, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y negative direction soft limit"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x009F, operate));

    // 软件限位允许，0，不允许，1，允许
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        160, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("software limit allowed"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00A0, operate));

    // 上料点坐标X1，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        161, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Loading point coordinate X1"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A1, operate));

    // 上料点坐标X2，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        162, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Loading point coordinate X2"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A2, operate));

    // 上料点坐标Y，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        163, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Loading point coordinate Y"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A3, operate));

    // 排胶点坐标X，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        164, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Coordinate X of glue discharge point"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A4, operate));

    // 排胶点坐标Y，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        165, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Coordinate Y of glue discharge point"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A5, operate));

    // 左右工位间隔距离X，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        166, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Distance between left and right stations X"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A6, operate));

    // 左右工位间隔距离Y，范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        167, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Distance between left and right stations Y"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A7, operate));

    // 工位1可工作范围X+，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        168, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Workable range X+ of station 1"),
                                        1000000, -1000000, 1000000, 1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A8, operate));

    // 工位1可工作范围X-，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        169, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Workable range X- of station 1"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00A9, operate));

    // 工位2可工作范围X+，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        170, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Workable range X+ of station 2"),
                                        1000000, -1000000, 1000000, 1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AA, operate));

    // 工位2可工作范围X-，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        171, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Workable range X- of station 2"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AB, operate));

    // 可工作范围Y+，范围-1000000--1000000，单位0.01mm,默认1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        172, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Working range Y+"),
                                        1000000, -1000000, 1000000, 1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AC, operate));

    // 可工作范围Y-，范围-1000000--1000000，单位0.01mm,默认-1000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        173, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Working range Y-"),
                                        -1000000, -1000000, 1000000, -1000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AD, operate));

    // 工位1升降低位坐标,范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        174, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Station 1 lifting low position coordinate"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AE, operate));

    // 工位2升降低位坐标,范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Station 2 lifting low position coordinate"),
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00AF, operate));

    // 越框时机头抬起高度,0--100000，单位0.01mm，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        176, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lifting height when crossing frame"),
                                        500, 0, 100000, 500, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x00B0, operate));

    //自动排胶等待时间，范围0-1000，单位分，默认30
    m_allParasList.append(makeAParaItem(0,
                                    PARA_TYPE_MACH,
                                    MC_SORT_SETTING,
                                    179, 0, 0, PARA_VALUE_TYPE_INT,
                                    tr("Automatic glue discharge waiting time"),// 自动排胶等待时间
                                    30, 0, 1000, 30, 0, tr("min"), tr(""),
                                    tr(""), 0, 0, 0x00B0, operate));

    //自动排胶持续时间，范围0-100，单位秒，默认10
    m_allParasList.append(makeAParaItem(0,
                                    PARA_TYPE_MACH,
                                    MC_SORT_SETTING,
                                    180, 0, 0, PARA_VALUE_TYPE_INT,
                                    tr("Automatic glue discharge duration"),// 自动排胶持续时间
                                    10, 0, 100, 10, 0, tr("s"), tr(""),
                                    tr(""), 0, 0, 0x00B0, operate));

    //开机自动复位允许，0，不允许，1，允许
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        200, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Power on automatic reset allowed"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00C8, operate));

    //  模拟工作功能，0，不允许，1，允许。
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        201, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Analog working function"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00C9, operate));

    // 启动按钮模式，范围0-10，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        202, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Start button mode"),
                                        0, 0, 10, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00CA, operate));

    // 自动补胶功能，0，不允许，1，允许
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        203, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Automatic glue filling function"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00CB, operate));

    // 双工位模式，0，关，1，开
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        204, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Dual station mode"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x00CC, operate));
}

//电机和控制动作
void AdhesiveMachine::initOutCtrlList()
{
    m_allOutCtrlList.clear();

    QString enableStr = tr("Enable");   //使能
    QString disableStr = tr("Disable"); //失能
    QString jogPStr = tr("JogP"); //正转
    QString jogNStr = tr("JogN"); //反转
    QString zeroStr = tr("Zero"); //归零
    QString openStr = tr("Open"); //打开
    QString closeStr = tr("Close");//关闭

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("X to move motor"),MT_LX,// X向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0002,tr("Y to move motor"),MT_LY,// Y向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("Lifting motor"),MT_LM,// 升降电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Glue gun control"),OT_GLUE_CTRL,// 胶枪控制
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0005,tr("A Pneumatic ball valve of large rubber pump"),OT_AL_GLUE_CTRL,// A大胶泵气动球阀
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Feeding control of small glue pump A"),OT_AS_GLUE_CTRL,// A小胶泵补料控制
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0007,tr("B Pneumatic ball valve of large rubber pump"),OT_BL_GLUE_CTRL,// B大胶泵气动球阀
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0008,tr("B Feeding control of small glue pump"),OT_BS_GLUE_CTRL,// B小胶泵补料控制
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));
}

//快捷功能
void AdhesiveMachine::initShortCutList()
{
    m_allShortCutList.clear();

    m_allShortCutList.append(makeAShortCutItem(0,0x0001,tr("Reset All"),"buttonProcessReset",FUN_RESETALL));//全部复位
    m_allShortCutList.append(makeAShortCutItem(0,0x0002,tr("Motor Zeroing"),"buttonAllToZero",FUN_MOTORZEROING));//电机归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0003,tr("Station1 Gluing"),"buttonStationGluing",FUN_STATION1GLUING));//工位1涂胶
    m_allShortCutList.append(makeAShortCutItem(0,0x0004,tr("Station2 Gluing"),"buttonStationGluing",FUN_STATION2GLUING));//工位2涂胶
    m_allShortCutList.append(makeAShortCutItem(0,0x0005,tr("Head Up And Down"),"buttonHeadUpDn",FUN_HEADUPDOWN));//机头升降
    m_allShortCutList.append(makeAShortCutItem(0,0x0006,tr("To Station1 Start"),"buttonBackAnchorPoint",FUN_TOSTATION1APOS));//回工位1起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x0007,tr("To Station2 Start"),"buttonBackAnchorPoint",FUN_TOSTATION2APOS));//回工位2起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x0008,tr("Work Pause"),"buttonSpindleDisable",FUN_WORKPAUSE));// 暂停工作
    m_allShortCutList.append(makeAShortCutItem(0,0x0009,tr("To Waitting Point"),"buttonBackFeedingPoint",FUN_TO_WAITTING_POS));//回等料点
    m_allShortCutList.append(makeAShortCutItem(0,0x000A,tr("To Adhesive Point"),"buttonToGluePos",FUN_TO_REMOVE_GLUE_POS));//回排胶点
    m_allShortCutList.append(makeAShortCutItem(0,0x000B,tr("Arrange Adhesive Once"),"buttonStationGluing",FUN_REMOVE_GLUE_ONCE));//排一次胶
    m_allShortCutList.append(makeAShortCutItem(0,0x0006,tr("Set Offset"),"buttonSetOffsetPoint",FUN_SETOFFSETPOINT));//定偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x0007,tr("Back Offset"),"buttonBackOffsetPoint",FUN_BACKOFFSETPOINT));//回偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x000C,tr("Sew Set Start"),"buttonSetAnchorPoint",FUN_SETSTARTPOINT));//缝纫定起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x000D,tr("Back Start"),"buttonBackAnchorPoint",FUN_BACKSTARTPOINT));//回起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x000F,tr("Check Frame"),"buttonBorderCheck",FUN_CHECKFRAME));//边框检查
    m_allShortCutList.append(makeAShortCutItem(0,0x0010,tr("Forward And Back"),"buttonForwardOrBack",FUN_FORWARDORBACK));//前进回退
    m_allShortCutList.append(makeAShortCutItem(0,0x0011,tr("Adjust Glue Height"),"buttonAdjustGlueHeight",FUN_ADJUST_GLUE_HEGHT));//校准胶管高度
}

//辅助功能
void AdhesiveMachine::initAssistList()
{
    m_allAssistList.clear();

    m_allAssistList.append(makeAAssistItem(0,0x0001,tr("SensorSign"),"buttonSensor",ASSIST_SENSOR));//传感器信号
    m_allAssistList.append(makeAAssistItem(0,0x0002,tr("Action"),"buttonControlAction",ASSIST_CONTROLACTION));//控制动作
    m_allAssistList.append(makeAAssistItem(0,0x0003,tr("HMI Upgrade"),"buttonHMIUpgrade",ASSIST_HMIUPGRADE));//界面升级
    m_allAssistList.append(makeAAssistItem(0,0x0004,tr("MC Upgrade"),"buttonMCUpgrade",ASSIST_MCUPGRADE));//主控升级
    m_allAssistList.append(makeAAssistItem(0,0x0006,tr("ParaImport"),"buttonParaImport",ASSIST_PARAIMPORT));//参数导入
    m_allAssistList.append(makeAAssistItem(0,0x0007,tr("ParaExport"),"buttonParaExport",ASSIST_PARAEXPORT));//参数导出
    m_allAssistList.append(makeAAssistItem(0,0x0008,tr("SoftwareSet"),"buttonSoftwareSet",ASSIST_SOFTWARESET));//软件设置
    m_allAssistList.append(makeAAssistItem(0,0x0009,tr("SoftPower"),"buttonSoftwareAuthor",ASSIST_AUTHORIZATION));//软件授权
    m_allAssistList.append(makeAAssistItem(0,0x000A,tr("Network"),"buttonNetworkManage",ASSIST_NETWORK));//网络管理
    //m_allAssistList.append(makeAAssistItem(0,0x000B,tr("NeedleSet"),"buttonNeedleSet",ASSIST_NEEDLESET));//针杆设置
    m_allAssistList.append(makeAAssistItem(0,0x000C,tr("TimeSet"),"buttonTimeSet",ASSIST_TIMESET));//时间设置
    m_allAssistList.append(makeAAssistItem(0,0x000F,tr("Version"),"buttonVersionInfo",ASSIST_MCVERSION));//版本信息
    m_allAssistList.append(makeAAssistItem(0,0x0014,tr("Root"),"buttonRoot",ASSIST_ROOT));//超级用户
}

//花样设置
void AdhesiveMachine::initPatternSetList()
{
    m_allPatternSetList.clear();

    //m_allPatternSetList.append(makeAPatternSetItem(0,0x0001,tr("Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT));//花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0002,tr("Para"),"buttonPatternPara",PATTERNSET_PATTERNPARA));//花样参数
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0003,tr("SpeedGear"),"buttonPatternColorOrder",PATTERNSET_PATTERNCOLOR));//速度档位
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0003,tr("HeadHeight"),"buttonPatternColorOrder",PATTERNSET_PATTERNCOLOR_HEADHIGHT));//机头高度
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0004,tr("Import"),"buttonPatternImport",PATTERNSET_PATTERNIMPORT));//花样导入
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0005,tr("Export"),"buttonPatternExport",PATTERNSET_PATTERNEXPORT));//花样导出
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0006,tr("Delete"),"buttonPatternDelete",PATTERNSET_PATTERNDELETE));//花样删除
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0007,tr("Station1Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT_STATION1));//工位1花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0008,tr("Station2Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT_STATION2));//工位2花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0009,tr("PatternSwitching"),"buttonPatternSwitching",PATTERNSET_PATTERN_SWITCHING));//花样切换
}

//参数分类(参数分组功能)
void AdhesiveMachine::initParaSetList()
{
    m_allParaSetList.clear();

    m_allParaSetList.append(makeAParaSetItem(0,0x0001,tr("OperatPara"),"buttonOperatParas",PARASET_SETTING));//设置参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0002,tr("ActionSet"),"buttonActionParas",PARASET_ACTION));//动作参数   //动作设定
    m_allParaSetList.append(makeAParaSetItem(0,0x0003,tr("SpeedPara"),"buttonSpeedParas",PARASET_SPEED));//速度参数  //速度控制参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0004,tr("LimitPara"),"buttonPositionParas",PARASET_POSITION));// 位置参数  //限位参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0005,tr("MCPara"),"buttonSettingParas",PARASET_DETECT));//检测参数    //机器参数
}

//初始化传感器列表
void AdhesiveMachine::initSensorList()
{
    QList <SensorItem> sensorList;

    sensorList.append(makeASensorItem(0x0200, 0, tr("X motor - zero position")));//X电机-零位
    sensorList.append(makeASensorItem(0x0200, 1, tr("X motor - positive limit")));//X电机-正限位
    sensorList.append(makeASensorItem(0x0200, 2, tr("X motor - negative limit")));//X电机-负限位
    sensorList.append(makeASensorItem(0x0200, 3, tr("Rubber discharge position of X motor")));//X电机排胶位
    sensorList.append(makeASensorItem(0x0200, 4, tr("Y motor - zero position")));//Y电机-零位
    sensorList.append(makeASensorItem(0x0200, 5, tr("Y motor - positive limit")));//Y电机-正限位
    sensorList.append(makeASensorItem(0x0200, 6, tr("Y motor - negative limit")));//Y电机-负限位
    sensorList.append(makeASensorItem(0x0200, 7, tr("Rubber discharge position of Y motor")));//Y电机排胶位

    sensorList.append(makeASensorItem(0x0201, 0, tr("Low liquid level alarm of large rubber pump A")));//A大胶泵低液位预警
    sensorList.append(makeASensorItem(0x0201, 1, tr("Low liquid level shutdown of large rubber pump A")));//A大胶泵低液位停机
    sensorList.append(makeASensorItem(0x0201, 2, tr("Low liquid level alarm of large rubber pump B")));//B大胶泵低液位预警
    sensorList.append(makeASensorItem(0x0201, 3, tr("Low liquid level shutdown of large rubber pump B")));//B大胶泵低液位停机
    sensorList.append(makeASensorItem(0x0201, 4, tr("High liquid level replenishment of small rubber pump A is completed")));//A小胶泵高液位补液完成
    sensorList.append(makeASensorItem(0x0201, 5, tr("Low liquid level alarm of small rubber pump A")));//A小胶泵低液位预警
    sensorList.append(makeASensorItem(0x0201, 6, tr("Stop at low liquid level of small glue pump A")));//A小胶泵低液位停机
    sensorList.append(makeASensorItem(0x0201, 7, tr("High liquid level replenishment of small glue pump B is completed ")));//B小胶泵高液位补液完成

    sensorList.append(makeASensorItem(0x0202, 0, tr("Low liquid level alarm of small rubber pump B")));//B小胶泵低液位预警
    sensorList.append(makeASensorItem(0x0202, 1, tr("Shutdown of small glue pump B at low liquid level")));//B小胶泵低液位停机
    sensorList.append(makeASensorItem(0x0202, 4, tr("Z motor - zero position")));//Z电机-零位
    sensorList.append(makeASensorItem(0x0202, 5, tr("Z motor - positive limit")));//Z电机-正限位
    sensorList.append(makeASensorItem(0x0202, 6, tr("Z motor - negative limit")));//Z电机-负限位

    sensorList.append(makeASensorItem(0x0203, 0, tr("Station 1 left limit")));//工位1左限位
    sensorList.append(makeASensorItem(0x0203, 1, tr("Station 1 right limit")));//工位1右限位
    sensorList.append(makeASensorItem(0x0203, 2, tr("Station 2 left limit")));//工位2左限位
    sensorList.append(makeASensorItem(0x0203, 3, tr("Station 2 right limit")));//工位2右限位

    //将机型所需的传感器列表替换到传感器整体列表中
    for(int i = 0; i < sensorList.size(); i++)
    {
        int byteaddr = sensorList[i].m_byte_offset;
        int bitaddr = sensorList[i].m_bit_offset;
        QString str = sensorList[i].m_name;
        int type = sensorList[i].m_type;

        int idx = byteaddr*8+bitaddr;
        if(idx < m_allSensorList.size())
        {
            m_allSensorList[idx].m_name = str;
            m_allSensorList[idx].m_type = type;
        }
    }
}

//初始化错误代码和状态列表
void AdhesiveMachine::initErrorCodeAndStateList()
{
    m_allErrorCodeAndStateList.clear();

    //错误代码
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PLC_DIS, tr("PLC is not allowed to work")));// PLC不允许工作
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PLC_LRNF, tr("Left and right stations are not ready")));// 左右工位未就绪
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PLC_LNF, tr("Left station is not ready")));// 左工位未就绪
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PLC_RNF, tr("Right station is not ready")));// 右工位未就绪
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_MC_NW, tr("The device has not started to work")));// 设备未开始工作
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_MTX_WP, tr("X motor position is abnormal")));// X电机位置异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_MTY_WP, tr("Abnormal position of Y motor")));// Y电机位置异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_WK_STA_NI, tr("The working state is not initialized")));// 工作状态未初始化
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_AL_LACK, tr("A large glue pump is short of glue")));// A大胶泵缺胶
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_BL_LACK, tr("B large rubber pump is short of glue")));// B大胶泵缺胶
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_AS_LACK, tr("A small glue pump is short of glue")));// A小胶泵缺胶
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_BS_LACK, tr("The small rubber pump B is short of glue")));// B小胶泵缺胶
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_NOT_RMPOS, tr("The rubber discharge position is not reached")));// 未到排胶位
}

