#ifndef ADHESIVEMACHINE_H
#define ADHESIVEMACHINE_H

#include "mctype/machinetypefun.h"

//控制动作
#define	OT_GLUE_CTRL                    0x0001		// 胶枪控制
#define	OT_AL_GLUE_CTRL				0x0002		// A大胶泵气动球阀
#define	OT_AS_GLUE_CTRL				0x0003		// A小胶泵补料控制
#define	OT_BL_GLUE_CTRL				0x0004		// B大胶泵气动球阀
#define	OT_BS_GLUE_CTRL				0x0005		// B小胶泵补料控制

//错误代码
#define ERR_PLC_DIS					0x0650		// PLC不允许工作
#define ERR_PLC_LRNF				0x0651		// 左右工位未就绪
#define ERR_PLC_LNF					0x0652		// 左工位未就绪
#define ERR_PLC_RNF					0x0653		// 右工位未就绪
#define ERR_MC_NW					0x0654		// 设备未开始工作
#define ERR_MTX_WP					0x0655		// X电机位置异常
#define ERR_MTY_WP					0x0656		// Y电机位置异常
#define ERR_WK_STA_NI				0x0657		// 工作状态未初始化

#define ERR_AL_LACK					0x0658		// A大胶泵缺胶
#define ERR_BL_LACK					0x0659		// B大胶泵缺胶
#define ERR_AS_LACK					0x065A	// A小胶泵缺胶
#define ERR_BS_LACK					0x065B		// B小胶泵缺胶
#define ERR_NOT_RMPOS			0x065C		// 未到排胶位

//压胶机
class AdhesiveMachine : public MachineTypeFun
{
    Q_OBJECT
public:
    AdhesiveMachine();
    ~AdhesiveMachine();

private:
    void initRootParasList();//超级用户参数(包括机器参数、工作参数)
    void initPatternsParasList();//花样参数
    void initMcParasList();//主控机器参数

private:
    void initOutCtrlList();//控制动作
    void initShortCutList();//快捷动作
    void initAssistList();//辅助功能
    void initPatternSetList();//花样设置
    void initParaSetList();//参数设置

private:
    void initSensorList();//初始化传感器列表
    void initErrorCodeAndStateList();//初始化错误代码和状态列表
};

#endif // ADHESIVEMACHINE_H
